<template>
  <div class="home">
    <img src="@/assets/images/banner.png" class="banner" />

    <h4 class="title">PRODUCT</h4>

    <div v-for="item in dataMain" :key="item.name" v-show="!showTable">
      <div @click="changeProduct(item)">
        <Product :name="item.name" :count="item.count" />
      </div>
      <transition name="fade">
        <div>
          <Subproduct
            v-if="item.showChild"
            @setTablesData="setTablesData"
            :content="item.sub"
          />
        </div>
      </transition>
    </div>

    <Table v-if="showTable" :tableData="tableData" />
  </div>
</template>

<script>
import Product from '@/components/Product.vue'
import Subproduct from '@/components/Subproduct.vue'
import Table from '@/components/Table.vue'
import main from '@/assets/data/main.json'
// import invoice from '@/assets/data/invoice/invoice.json'
// import osf from '@/assets/data/osf/osf.json'

export default {
  name: 'Home',
  components: {
    Product,
    Subproduct,
    Table
  },
  data() {
    return {
      dataMain: main.contents,
      showTable: false,
      tableData: []
    }
  },
  created() {
    this.initialLoad()
  },
  methods: {
    initialLoad() {
      this.dataMain.forEach((element) => {
        element.showChild = false
      })
    },
    changeProduct(item) {
      const jsonProduct = require(`@/assets/data/${item.sub}`)
      if (jsonProduct.contents[0].sub) {
        item.showChild = !item.showChild
      } else {
        this.setTablesData(jsonProduct.contents)
      }
      this.dataMain = [...this.dataMain]
      // console.log(item)
    },
    setTablesData(data) {
      this.showTable = true
      this.tableData = data
    }
  }
}
</script>

<style scoped>
.home {
  display: block;
  margin-left: auto;
  margin-right: auto;
  width: 50%;
  margin-top: 5px;
}
.banner {
  width: 100%;
}

.title {
  margin-top: 40px;
  margin-bottom: 10px;
  text-align: left;
}

@media (max-width: 767px) {
  .home {
    width: 100%;
  }
}

.fade-enter-active,
.fade-leave-active {
  transition: opacity 0.5s;
}
.fade-enter, .fade-leave-to /* .fade-leave-active below version 2.1.8 */ {
  opacity: 0;
}
</style>
